'Debug 8503
'=====================================================================
'{ACERCA DE IDEALEDIT}
'{ABOUT IDEALEDIT}
'=====================================================================
'IdealEdit by Angel Berbel,2012
'IdealEdit es libre y de cdigo abierto
'IdealEdit is free and open source 
'IdealEdit pretender ser una grata experiencia y un ejemplo de programacin
'IdealEdit intended to be a pleasant experience and a programming example
'=====================================================================
'{RECURSOS}
'====================================================================
Resource BMP_Nuevo as "\Recursos\nuevo16x16.bmp"
Resource BMP_Abrir as "\Recursos\Abrir16x16.bmp"

'======================================================================
'{CONSTANTES Y VARIABLES GLOBALES}
'======================================================================
Const clGris=&H808080
Const clRojo=&H0000FF
Const clNegro=&H000000
Dim expandirLibre as boolean
Dim rchModificado1 as boolean
Dim rchModificado2 as boolean
'======================================================================
'{ARCHIVOS INI}
'======================================================================

Dim iniConfig as iniFile
  iniconfig.open (exepath+"idealEdit.ini")
Dim iniLeng as iniFile
  Select case ucase$(iniconfig.readstr("Idiomas\Lenguaje"))
    Case "INGLES" 
      iniLeng.Open (exepath+"Ingles.lng")
    Case "FRANCES"
      'no incluido
      'iniLeng.Open (exepath+"Frances.lng")
    Case else
      iniLeng.Open (exepath+"Espaol.lng")
  End Select
'========================================================================================
'{OBJETOS DIM}
'========================================================================================
Dim btmTabEditor as Bitmap
btmTabEditor.Transparent=True
btmtabEditor.TransparentMode=TmAuto
btmTabEditor.loadFromFile(exePath+"\Recursos\Nuevo16x16.bmp")

'========================================================================================
'{GUI}
'========================================================================================
Object frmPrincipal As Form
  Caption="IdealEdit"
  Height=480
  Width=665
  'BorderIcons=1
  'BorderStyle=1
  'Center
  'Otros objetos
  Object staEstado As Statusbar
    Simpletext=false
    Addpanel
    Addpanel
    Panelwidth(0)=100
  End Object
'------------------------------------------------------------------------------------>MEN
  Object mnuPrincipal as Mainmenu
    Object mnuArchivo as Menuitem
      Caption= inileng.readStr("Menu\Archivo")
      Object mnuNuevo as Menuitem
        Tag=0
        Caption=iniLeng.ReadStr("Menu\Nuevo")
        shortcut="CTRL+N"
        bmpResource(BMP_nuevo)
        'Onclick=Mnu_Onclick
      End object
      Object mnuAbrir as Menuitem
        Tag=1
        Caption=iniLeng.ReadStr("Menu\Abrir")
        shortcut="CTRL+O"
        bmpResource(BMP_Abrir)
        'Onclick=Mnu_Onclick
      end object
      Object mnuAbrirRecientes as Menuitem
        'Tag=1
        Caption=iniLeng.ReadStr("Menu\AbrirRecientes")
        'shortcut="CTRL+O"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
       Object mnuRecientes1 as Menuitem
          Tag=2
          Caption="..."
          'shortcut="CTRL+O"
         'bmpResource(resource)
         'Onclick=Mnu_Onclick
        end object
        Object mnuRecientes2 as Menuitem
          Tag=3
          Caption="..."
          'shortcut="CTRL+O"
         'bmpResource(resource)
         'Onclick=Mnu_Onclick
        end object
         Object mnuRecientes3 as Menuitem
          Tag=4
          Caption="..."
          'shortcut="CTRL+O"
         'bmpResource(resource)
         'Onclick=Mnu_Onclick
        end object
        Object mnuRecientes4 as Menuitem
          Tag=5
          Caption="..."
          'shortcut="CTRL+O"
         'bmpResource(resource)
         'Onclick=Mnu_Onclick
        end object
      End Object
      Object mnuGuardar as Menuitem
        Tag=4
        Caption=iniLeng.ReadStr("Menu\Guardar")
        shortcut="CTRL+S"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuGuardarComo as Menuitem
        Tag=5
        Caption=iniLeng.ReadStr("Menu\GuardarComo")
        'shortcut="CTRL+S"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuSeparador1 as Menuitem
         Caption="-"
      End Object
      Object mnuImprimir as Menuitem
        Tag=6
        Caption=iniLeng.ReadStr("Menu\Imprimir")
        Shortcut="CTRL+P"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuSeparador2 as Menuitem
         Caption="-"
      End Object
      Object mnuSalir as Menuitem
        Tag=7
        Caption=iniLeng.ReadStr("Menu\Salir")
        Shortcut="CTRL+E"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
    end object
    Object mnuEdicion as Menuitem
      Caption=iniLeng.ReadStr("Menu\Edicion")
      Object mnuDeshacer as Menuitem
        Tag=8
        Caption=iniLeng.ReadStr("Menu\Deshacer")
        Shortcut="CTRL+Z"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuCortar as Menuitem
        Tag=9
        Caption=iniLeng.ReadStr("Menu\Cortar")
        Shortcut="CTRL+X"
        'bitmap.LoadFromResource("cutXP.bmp")
        'bmpResource(Resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuCopiar as Menuitem
        Tag=10
        Caption=iniLeng.ReadStr("Menu\Copiar")
        Shortcut="CTRL+C"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuPegar as Menuitem
        Tag=11
        Caption=iniLeng.ReadStr("Menu\Pegar")
        Shortcut="CTRL+V"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuSeparador3 as Menuitem
         Caption="-"
      End Object
      Object mnuSeleccionarTodo as Menuitem
        Tag=12
        Caption=iniLeng.ReadStr("Menu\SeleccionarTodo")
        Shortcut="CTRL+A"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuComentar as Menuitem
        Tag=13
        Caption=iniLeng.ReadStr("Menu\Comentar")
        'Shortcut="CTRL+V"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuQuitarLineasVacias as Menuitem
        Tag=14
        Caption=iniLeng.ReadStr("Menu\QuitarLineasVacias")
        'Shortcut="CTRL+V"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuBorrarLinea as Menuitem
        Tag=15
        Caption=iniLeng.ReadStr("Menu\BorrarLinea")
        'Shortcut="CTRL+V"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuSeparador4 as Menuitem
         Caption="-"
      End Object
      Object mnuPreferencias as Menuitem
        Tag=16
        Caption=iniLeng.ReadStr("Menu\Preferencias")
        'Shortcut="CTRL+V"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
    end object
    Object mnuBuscar as Menuitem
      Caption=iniLeng.ReadStr("Menu\Buscar")
      Object mnuBuscarReemplazar as Menuitem
        Tag=17
        Caption=iniLeng.ReadStr("Menu\BuscarReemplazar")
        Shortcut="CTRL+F"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuIrLinea as Menuitem
        Tag=18
        Caption=iniLeng.ReadStr("Menu\Irlinea")
        Shortcut="CTRL+G"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
    End Object
    Object mnuEjecutar as Menuitem
      Caption=iniLeng.ReadStr("Menu\Ejecutar")
      Object mnuCompilar as Menuitem
        Tag=19
        Caption=iniLeng.ReadStr("Menu\Compilar")
        'Shortcut="CTRL+F"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuCompilarEjecutar as Menuitem
        Tag=20
        Caption=iniLeng.ReadStr("Menu\CompilarEjecutar")
        Shortcut="F9"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
    End object
    Object mnuAyuda as Menuitem
      Caption=iniLeng.ReadStr("Menu\Ayuda")
      Object mnuFNXAyuda as Menuitem
        Tag=21
        Caption=iniLeng.ReadStr("Menu\AyudaFNX")
        Shortcut="F1"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuAyudaEditor as Menuitem
        Tag=22
        Caption=iniLeng.ReadStr("Menu\AyudaEditor")
        'Shortcut="F9"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
      Object mnuAcercaDe as Menuitem
        Tag=23
        Caption=iniLeng.ReadStr("Menu\AcercaDe")
        'Shortcut="F9"
        'bmpResource(resource)
        'Onclick=Mnu_Onclick
      end object
    End Object
  End Object
'--------------------------------------------------------------------------->FIN MEN
'--------------------------------------------------------------------->PANEL SUPERIOR
  Object pnlSuperior as Panel
    Align=altop
    Bevelinner =1
    Height=30
    OnmouseMove=autoOcultar_OnMouseMove

    Object btnFaceNuevo as facebutton
      Tag=100
      Left=10
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.readStr("barra superior\HintNuevo")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Nuevo.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceAbrir as facebutton
      Tag=101
      Left=38
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintAbrir")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Abrir.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceGuardar as facebutton
      Tag=102
      Left=66
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintGuardar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Guardar.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceImprimir as facebutton
      Tag=103
      Left=94
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintImprimir")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\imprimir.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object imgSeparador1 as image
      Top=2
      Left=122
      Width=3
      height=26
      'Transparent=True
      canvas.line(1,3,1,26,clGris)
    End object
    Object btnFaceDeshacer as facebutton
      Tag=104
      Left=130
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintDeshacer")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Deshacer.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceCortar as facebutton
      Tag=105
      Left=158
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintCortar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Cortar.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceCopiar as facebutton
      Tag=106
      Left=186
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintCopiar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Copiar.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object btnFacepegar as facebutton
      Tag=107
      Left=214
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintPegar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Pegar.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object imgSeparador2 as image
      Top=2
      Left=242
      Width=3
      height=26
      'Transparent=True
      canvas.line(1,3,1,26,clGris)
    End object
    Object btnFaceBuscar as facebutton
      Tag=108
      Left=250
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintBuscar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Buscar.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object imgSeparador3 as image
      Top=2
      Left=278
      Width=3
      height=26
      'Transparent=True
      canvas.line(1,3,1,26,clGris)
    End object
    Object btnFaceEjecutar as facebutton
      Tag=109
      Left=286
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintEjecutar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Ejecutar.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
    Object imgSeparador4 as image
      Top=2
      Left=314
      Width=3
      height=26
      'Transparent=True
      canvas.line(1,3,1,26,clGris)
    End object
    Object btnFaceAyudaFNX as facebutton
      Tag=110
      Left=322
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintAyudaFNX")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Ayuda.bmp")
      'OnClick=pnlSuperior_OnClick
    End Object
  End object
'--------------------------------------------------------------->FIN PANEL SUPERIOR
'--------------------------------------------------------------->PANEL IZQUIERDO
   Object pnlIzquierdo as Panel
     Align=alleft
     Bevelinner =2
     Width=380
     Object btnAutoOcultar as Button
       'Tag=109
       Left=3
       Top=3
       Width=26
       Height=26
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintFijar")
       ShowHint=True
       Bitmap.loadfromfile(exepath+"\Recursos\Fijo.bmp")
       OnClick=AutoOcultar_OnClick
     End Object
     Object imgTitulo as image
       left=90
       Top=5
       width=285
       Height=30
       Canvas.rectangle(0,0,285,30,clGris)
       Canvas.fill(1,1,clrojo,clnegro)
     end object
     Object btnFaceHerramientas as facebutton
       Tag=200
       Left=5
       Top=60
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionHerramientas")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintHerramientas")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Herramientas.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object
     Object btnFaceNotas as facebutton
       Tag=201
       Left=5
       Top=115
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionNotas")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintNotas")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Notas.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object
    Object btnFaceCalculadora as facebutton
       Tag=202
       Left=5
       Top=170
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionCalculadora")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintCalculadora")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Calculadora.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object
     Object btnFaceColores as facebutton
       Tag=203
       Left=5
       Top=225
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionColores")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintColores")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Colores.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object

     Object btnFaceKeyCodes as facebutton
       Tag=204
       Left=5
       Top=280
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionCodigos")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintCodigos")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Caracter.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object
'-------------------------------------->Grupo Herramientas
     Object grpHerramientas as Groupbox
       Top=40
       left=90
       width=285
       Height=918
       Object grpObjetos as Groupbox
         Top=5
         left=5
         width=grpHerramientas.Width-10
         Height=400
         Caption=iniLeng.ReadStr("Panel Izquierdo\CaptionObjetos")
         Object lblSangria as label
           Left=5
           Top=15
           Width=90
           Caption=iniLeng.ReadStr("Panel Izquierdo\CaptionSangria")
           Transparent=True
         End Object
         Object edtSangria as Edit
           Top=15
           Left=95
           Width=30
           Text="1"
         End Object
         Object btnFlechaArriba as Button
            Tag=250
            left=128
            Top=15
            Width=25
            Height=12
            Hint=iniLeng.ReadStr("Panel Izquierdo\HintFlechaArriba")
            ShowHint=True
            Cursor=-21
            Bitmap.LoadFromFile(exepath+"\Recursos\FlechaArriba.bmp")
            'Onclick=btnSangria_OnClick
         End Object
         Object btnFlechaAbajo as Button
            tag=251
            left=128
            Top=27
            Width=25
            Height=12
            Hint=iniLeng.ReadStr("Panel Izquierdo\HintFlechaAbajo")
            ShowHint=True
            Cursor=-21
            Bitmap.LoadFromFile(exepath+"\Recursos\FlechaAbajo.bmp")
            'Onclick=btnSangra_OnClick
         End Object
         Object btnPrdeterminado as Button
            Tag=252
            left=158
            Top=15
            Width=110
            Height=20
            Caption=iniLeng.ReadStr("Panel Izquierdo\CaptionValorInicial")
            Cursor=-21
            Hint=iniLeng.ReadStr("Panel Izquierdo\HintValorInicial")
            ShowHint=True
            'Bitmap.LoadFromFile(exepath+"\Recursos\FlechaAbajo.bmp")
            'Onclick=btnSangra_OnClick
         End Object
         Object tabObjetos as tabControl
           Top=50
           Left=5
           Width=grpObjetos.Width-10
           Height=grpObjetos.Height-55
           addTab(iniLeng.Readstr("Panel Izquierdo\CaptionVisibles"))
           AddTab(iniLeng.Readstr("Panel Izquierdo\CaptionNoVisibles"))
           AddTab(iniLeng.Readstr("Panel Izquierdo\CaptionDialogos"))
           OnChange=tabObjetos_OnChange
           Object pnlVisibles as Panel
             align=alclient
             Object btnfaceBoton as facebutton
               Tag=300
                Left=5
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintButton")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\Boton.bmp")
                'OnClick=Objetos_OnClick
             End Object

           end object
           Object pnlNoVisibles as Panel
             align=alclient
             Visible=False
             Object lstNoVisibles as Listbox
               Top=5
               Left=5
               Width=pnlNoVisibles.Width-10
               Height=pnlNoVisibles.Height-10
               AddItem "Application"
               AddItem "Bitmap"
               AddItem "..............."
               AddItem "Etc"
               itemIndex=0
             End Object
           end object
           Object pnlDialogos as Panel
             align=alclient
             Visible=false
             Object btnfaceFileDialog as facebutton
               Tag=301
                Left=5
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintFileDialogo")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\FileDialogo.bmp")
                'OnClick=Objetos_OnClick
             End Object
             Object btnfaceFontDialog as facebutton
               Tag=302
                Left=36
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintFontDialogo")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\FontDialogo.bmp")
                'OnClick=Objetos_OnClick
             End Object
             Object btnfaceColorDialog as facebutton
               Tag=303
                Left=67
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintColorDialogo")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\ColorDialogo.bmp")
                'OnClick=Objetos_OnClick
             End Object
           end object
         End Object
       End object
       Object grpMacros as Groupbox
         Top=10+grpObjetos.Height
         left=5
         width=grpHerramientas.Width-10
         Height=500
         Caption=iniLeng.ReadStr("Panel Izquierdo\CaptionMacros")
         Object lstMacros as Listbox
           Top=15
           Left=5
           Width=grpMacros.Width-10
           Height=grpMacros.Height-20
           AddItem "For...Next"
           AddItem "Do...Loop Until"
           AddItem "..............."
           AddItem "Etc"
           itemIndex=0
         End Object
       End object
     End object
'------------------------------------->Fin Grupo Herramientas
     Object grpNotas as Groupbox
       Top=40
       left=90
       width=285
       Height=918
       Visible=False
     End object
     Object grpCalculadora as Groupbox
       Top=40
       left=90
       width=285
       Height=918
       Visible=False
     End object
     Object grpColores as Groupbox
       Top=40
       left=90
       width=285
       Height=918
       Visible=False
     End object
     Object grpCodigos as Groupbox
       Top=40
       left=90
       width=285
       Height=918
       Visible=False
     End object

   End Object
'-------------------------------------------------------------->FIN PANEL IZQUIERDO
'-------------------------------------------------------------->PANEL CENTRAL
   Object pnlCentral as Panel
     Align=alClient
     Object lstSubFun as Listbox
       Width=150
       align=alRight
       addItem "Subs and Func"
       itemIndex=0
     End Object
     Object splSplitter as Splitter
       Width=3
       Align=alright
     End Object
     Object pnlCentroSuperior1 as Panel
       Align=alTop
       Height=30
       OnmouseMove=autoOcultar_OnMouseMove
       Object lblBusquedaRapida as label
         Left=5
         Top=4
         Width=120
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionBusquedaRapida")
         Transparent=True
       End Object
       Object edtBusquedaRapida as Edit
         Top=4
         Left=130
         Width=120
       End Object
       Object btnBusquedaRapida as Button
         Top=4
         Width=120
         Height=20
         Left=255
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionBuscar")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintBuscar")
         Showhint=True
         Cursor=-21
       End Object
       Object btnBusquedaSiguiente as Button
         Top=4
         Width=120
         Height=20
         Left=380
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionSiguiente")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintSiguiente")
         ShowHint=True
         Cursor=-21
       End Object
       Object lblIrLinea as label
         Left=505
         Top=4
         Width=120
         Caption=iniLeng.readStr("Barras CentroSuperiores\LabelIr")
         Transparent=True
       End Object
       Object edtIrLinea as Edit
         Top=4
         Left=630
         Width=120
       End Object
       Object btnIrLinea as Button
         Top=4
         Width=120
         Height=20
         Left=755
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionIr")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintIr")
         ShowHint=True
         Cursor=-21
       End Object
       Object btnPrimeraLinea as Button
         Top=4
         Width=120
         Height=20
         Left=880
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionPrimeraLinea")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintPrimeraLinea")
         ShowHint=true
         Cursor=-21
       End Object
       Object btnUltimaLinea as Button
         Top=4
         Width=120
         Height=20
         Left=1005
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionUltimaLinea")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintUltimaLinea")
         ShowHint=True
         Cursor=-21
       End Object

     End object
     Object pnlCentroSuperior2 as Panel
       Align=alTop
       Height=30
       OnmouseMove=autoOcultar_OnMouseMove
       Object lblObjetos as label
         Left=5
         Top=4
         Width=120
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionObjetos")
         Transparent=True
       End Object
       Object cmbObjetos as ComboBox
         Left=130
         Top=4
         Width=350
       End Object
       Object lblVariables as label
         Left=485
         Top=4
         Width=120
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionVariables")
         Transparent=True
       End Object
       Object cmbVariables as ComboBox
         Left=595
         Top=4
         Width=350
       End Object
       Object lblFavoritos as label
         Left=950
         Top=4
         Width=120
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionFavoritas")
         Transparent=True
       End Object
       Object cmbFavoritos as ComboBox
         Left=1075
         Top=4
         Width=350
       End Object

     End object
     Object pnlCompilacion as Panel
       Align=albottom
       Height=70
       Object rchCompilacion as Richedit
         align=alClient
         Top=5
         Left=5
         Height=pnlCompilacion.height-10
         Width=pnlCompilacion.Width-10
         AddText("Log:")
         Color=val(iniConfig.readStr("Colores\Compilacion"))
         OnmouseMove=autoOcultar_OnMouseMove
       end Object
     End object
     Object tabEditor as tabControl
       Align=alClient
       addTab (iniLeng.readStr("TabEditor\Tab1"))
       AddTab(iniLeng.readStr("TabEditor\Tab2"))
       AddBMP(btmTabEditor)
       AddBMP(btmTabEditor)
       Onchange=tabeditor_OnChange
       Object rchNumeracion1 as richedit
         Align=alleft  
         Width=80
         Visible=True
         Color=val(iniConfig.readStr("Colores\Numeracion"))
         OnmouseMove=autoOcultar_OnMouseMove
       End Object
       Object rchNumeracion2 as richedit
         Align=alleft  
         Width=80
         Visible=False
         Color=val(iniConfig.readStr("Colores\Numeracion"))
         OnmouseMove=autoOcultar_OnMouseMove
       End Object
       Object rchEditor1 as richedit
         Align=alClient
         AddText("rchEditor1")
       End Object
       Object rchEditor2 as richedit
         Align=alClient
         Visible=false
         AddText("rchEditor2")
       End Object
     End Object
   End object
'--------------------------------------------------------------->FIN PANEL CENTRAL
'--------------------------------------------------------------->PANEL DERECHO
   Object pnlDerecho as Panel
     Align=alRight
     Bevelinner =2
     Width=56
     Object btnfaceCerrar as facebutton
       'Tag=201
       Left=15
       Top=10
       Width=26
       Height=26
       Flat=true
       Cursor=-21
       Hint=iniLeng.readStr("Barra Derecha\HintCerrar")
       ShowHint=True
       Bitmap.loadfromfile(exepath+"\Recursos\Cierra.bmp")
       'OnClick=btnFaceCerrar_OnClick
     End Object
   End object
'---------------------------------------------------------------->FIN PANEL DERECHO
  'Fin otros objetos
  OnShow= frmPrincipal_Onshow
End Object
'---------------------------------------------------------------->FIN FRMPRINCIPAL
'---------------------------------------------------------------->EJECUTAR (LOAD AND SHOW)
frmPrincipal.WindowState=WsMaximized
frmPrincipal.Showmodal
'---------------------------------------------------------------->FIN EJECUTAR
'======================================================================================================
'{SUBS Y FUNCS. MDULO PRINCIPAL}
'======================================================================================================
Sub frmPrincipal_OnShow
  Dim CoordX as integer
  Dim titulo as string
  titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo1"))
  coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
  imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
  expandirLibre=False
End sub
'======================================================================================================
Sub autoOcultar_Onclick(Sender as Button)
  If expandirLibre=true then
    Sender.bitmap.loadFromFile(exepath+"\Recursos\Fijo.bmp")
    expandirLibre=false
  else
    Sender.bitmap.loadFromFile(exepath+"\Recursos\Libre.bmp")
    expandirLibre=True
  end if
End sub
'=====================================================================================================
Sub autoOcultar_OnMouseMove
 if expandirLibre=True then pnlIzquierdo.Width=88
End Sub
'======================================================================================================
Sub panelIzquierdo_OnClick(Sender as facebutton)
  Dim CoordX as integer
  Dim titulo as string
  Select Case Sender.tag
    Case 200
      imgTitulo.Canvas.fill(1,10,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo1"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      grpHerramientas.visible=True
      grpNotas.visible=False
      grpCalculadora.visible=False
      grpColores.visible=False
      grpCodigos.visible=False
    Case 201
      imgTitulo.Canvas.fill(1,10,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo2"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      grpHerramientas.visible=False
      grpNotas.visible=True
      grpCalculadora.visible=False
      grpColores.visible=False
      grpCodigos.visible=False
    Case 202
      imgTitulo.Canvas.fill(1,1,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo3"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      grpHerramientas.visible=False
      grpNotas.visible=False
      grpCalculadora.visible=True
      grpColores.visible=False
      grpCodigos.visible=False
    Case 203
      imgTitulo.Canvas.fill(1,1,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo4"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      grpHerramientas.visible=False
      grpNotas.visible=False
      grpCalculadora.visible=False
      grpColores.visible=True
      grpCodigos.visible=False

    Case 204
      imgTitulo.Canvas.fill(1,1,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo5"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      grpHerramientas.visible=False
      grpNotas.visible=False
      grpCalculadora.visible=False
      grpColores.visible=False
      grpCodigos.visible=True
  End Select
End Sub
'======================================================================================================
Sub tabEditor_OnChange(Sender as TabControl)
  Select case Sender.TabIndex
    Case 0
      rchNumeracion2.Visible=False
      rchNumeracion1.Visible=True
      rchEditor2.Visible=False
      rcheditor1.Visible=True
    Case 1
      rchNumeracion1.visible=False
      rchNumeracion2.Visible=True
      rcheditor1.Visible=False
      rchEditor2.Visible=True
  End Select
End Sub
'======================================================================================================
Sub tabObjetos_OnChange(Sender as TabControl)
  Select case Sender.TabIndex
    Case 0
      pnlVisibles.Visible=True
      pnlNoVisibles.Visible=False
      PnlDialogos.Visible=False
    Case 1
      pnlVisibles.Visible=False
      pnlNoVisibles.Visible=True
      PnlDialogos.Visible=False
    Case 2
      pnlVisibles.Visible=False
      pnlNoVisibles.Visible=false
      PnlDialogos.Visible=True
  End Select
End Sub



